#include "build.h"
#include "../props/Props.h"
#include "Logo.h"
#include "ShowTree.h"
#include "Dialog.h"

#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>
#include <qdir.h> 
#include <qfiledlg.h> 
#include <qwidget.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qradiobt.h> 
#include <qpopmenu.h>
#include <qkeycode.h>
#include <qapp.h>
#include <qmsgbox.h>
#include <qpushbt.h>
#include <qevent.h> 
#include <qpoint.h>
#include <qlistbox.h>
#include <qrect.h>
#include <qlayout.h>
#include <qbttngrp.h>
#include <qslider.h>
#include <qmlined.h>
#include <qtabdlg.h>
#include <qlistbox.h>
#include <qlined.h>
#include <qgrpbox.h>
#include <qcombo.h>
#include <qstring.h>
#include <qcolor.h>
#include <qpalette.h>
#include <qscrbar.h>

class MainWindow;

//for chooser
class leftButton:public QPushButton
{
  Q_OBJECT
public:
  leftButton(QWidget *parent=0, const char *name=0,MainWindow *added=0,QPixmap onPic=QPixmap(),QPixmap offPic=QPixmap())
    :QPushButton(parent,name)
  {
    onPix=onPic;
    offPix=offPic;
    toDraw=added;
    setOn(TRUE);
    setMouseTracking(TRUE);
  }

  void setOn(bool val)
  {
    on=val;
    if(val)
      setPixmap(onPix);
    else
      setPixmap(offPix);
  }
  void sB(int val){code=val;}
  void setText(const char *val){text=val;}
signals:
  void lPress(int val);
private:
  int code;
  const char *text;
  bool on;
  QPixmap onPix,offPix;
  MainWindow *toDraw;
  
  void mousePressEvent(QMouseEvent *event)
  {
    if(on)
      {
	animateClick();
	emit lPress(code);
      }
  }  
  void enterEvent(QEvent *event);
  void leaveEvent(QEvent *event);
};

class left;
class up;
class down;

//Main

class MainWindow : public QWidget
{
Q_OBJECT
public:
  MainWindow(QWidget *parent=0, const char *name=0 );
  void setCode(int val){code=val;}
  void doThis(int val);
  void display(const char *text);
  void advertise();
  int whichLast() { return lastTouched->which; }
  void setActive(QWidget *widget,bool what,bool move=FALSE);
  QString getBigPath(){return bigPath;}
  QString getHomePath(){return homePath;}
  
  MyTree tree[NUMPROJECTS];
  MyTree *pasteTree;
 public slots:
  void newOne();
  void open();
  void save();
  void saveAs();
  void closeIt();
  void exit();
  void undo();
  void cut();
  void copy();
  void paste();
  void prefs();
  void gen();
  void classTree();
  void about();
  void aboutQt();
  bool takePress(QWidget *widget,QMouseEvent *event);
  void takeMove(QWidget *widget,QMouseEvent *event);
  void takeRelease(QWidget *widget,QMouseEvent *event);
  void takeDbClick(QWidget *widget,QMouseEvent *event);
  void setTouched(MyClass *widget);
  void clear(){advertise();}
  void watchMouse(int x,int y);
private:
  QString bigPath,homePath;
  QMenuBar *menu;
  QPopupMenu *edit,*file,*tools;
  Frame *active;
  left *chooser;
  up *shortcut;
  down *helptext;
  Dialog *middle;
  int state[NUMPROJECTS];
  int place,code,clicked,clickX,clickY;
  int srcItem,genItem,undoItem,cutItem,copyItem,pasteItem,prefsItem,saveItem,saveAsItem,closeItem;
  bool canUndo,undoProps,canPaste,canPrefs,canSave,canClose,PasteIT;
  MyClass *lastTouched;

  void prepare();
  void createWidget(QWidget *widget,QString id);
  void copyWidget(QWidget *widget,int x,int y,bool undo=FALSE); 
  void ShowReadTree(MyTree *t, QString s,int current);
  bool ShowWidget(MyTree *t, QWidget *parent,bool undo=FALSE,bool first=TRUE);
  void watchWidget(QWidget *widget);
  void saveIt(QString name,bool val);
  void in(int val,QWidget *wgt,QString *toPut);
  void setUndo(QWidget *widget,int cmd);
  int freeNum()
    {
      int i;
      for(i=0;i<NUMPROJECTS;i++)
	if(state[i]==0)
	  return i;
      return -1;
    }
  //things for undo
  QWidget *toUndo,*undoParent;
  int undoCMD;
  QString undoID;
  int undoT,undoX,undoY,undoW,undoH,u1,u2,u3,u4;
  MyTree *undoTree;

  QString *undoF1[NUMFEATURE1];
  int undoF2[NUMFEATURE2];
};

// left

class left: public QFrame
{
  Q_OBJECT
public:
  left(MainWindow *parent = NULL,const char *name = NULL);
  virtual ~left();
public slots:
void sendCode(int val){toSend->setCode(val);}
protected slots:
private:
 MainWindow *toSend;
 leftButton *b1,*b2,*b3,*b4,*b5,*b6,*b7,*b8,*b9,*b10,*b11,*b12,*b13,*b14,*b15,*b16,*b17,*b18,*b19,*b20,*b21,*b22,*b23,*b24,*b25,*b26;
};


//up

class up: public QFrame
{
  Q_OBJECT
public:
  up(MainWindow *parent= NULL,const char* name = NULL);
  void setOn(int item,bool val)
  {
    switch(item)
      {
      case 1: b1->setOn(val);
	break;
      case 2: b2->setOn(val);
	break;
      case 3: b3->setOn(val);
	break;
      case 4: b4->setOn(val);
	break;
      case 5: b5->setOn(val);
	break;
      case 6: b6->setOn(val);
	break;
      case 7: b7->setOn(val);
	break;
      case 8: b8->setOn(val);
	break;
      case 9: b9->setOn(val);
	break;	
      }
  }
  virtual ~up();
public slots:
void callIt(int val){toCall->doThis(val);}
protected slots:
private:
  MainWindow *toCall;
  leftButton *b1,*b2,*b3,*b4,*b5,*b6,*b7,*b8,*b9;
};

//down

class down : public QFrame
{
  Q_OBJECT  
public:
  down(MainWindow* parent = NULL,const char* name = NULL);
  void disp(const char *val){neon->setText(val);}
  void adv(){neon->setText("welcome to buildIT!");}
  virtual ~down();
public slots:
protected slots:
protected:
  QLabel *neon;
};






















